// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class SuctionGrasp {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.uuid = null;
      this.item_uuid = null;
      this.pose = null;
      this.quality = null;
      this.max_suction_surface_length = null;
      this.max_suction_surface_width = null;
    }
    else {
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
      if (initObj.hasOwnProperty('item_uuid')) {
        this.item_uuid = initObj.item_uuid
      }
      else {
        this.item_uuid = '';
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.PoseStamped();
      }
      if (initObj.hasOwnProperty('quality')) {
        this.quality = initObj.quality
      }
      else {
        this.quality = 0.0;
      }
      if (initObj.hasOwnProperty('max_suction_surface_length')) {
        this.max_suction_surface_length = initObj.max_suction_surface_length
      }
      else {
        this.max_suction_surface_length = 0.0;
      }
      if (initObj.hasOwnProperty('max_suction_surface_width')) {
        this.max_suction_surface_width = initObj.max_suction_surface_width
      }
      else {
        this.max_suction_surface_width = 0.0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type SuctionGrasp
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    // Serialize message field [item_uuid]
    bufferOffset = _serializer.string(obj.item_uuid, buffer, bufferOffset);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.PoseStamped.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [quality]
    bufferOffset = _serializer.float64(obj.quality, buffer, bufferOffset);
    // Serialize message field [max_suction_surface_length]
    bufferOffset = _serializer.float64(obj.max_suction_surface_length, buffer, bufferOffset);
    // Serialize message field [max_suction_surface_width]
    bufferOffset = _serializer.float64(obj.max_suction_surface_width, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type SuctionGrasp
    let len;
    let data = new SuctionGrasp(null);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [item_uuid]
    data.item_uuid = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.PoseStamped.deserialize(buffer, bufferOffset);
    // Deserialize message field [quality]
    data.quality = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [max_suction_surface_length]
    data.max_suction_surface_length = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [max_suction_surface_width]
    data.max_suction_surface_width = _deserializer.float64(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.uuid);
    length += _getByteLength(object.item_uuid);
    length += geometry_msgs.msg.PoseStamped.getMessageSize(object.pose);
    return length + 32;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/SuctionGrasp';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '449ec9cea56f81c8bacbaa03002e5dd4';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Definition of a suction grasp for the itempick component
    
    string uuid
    
    # Optional
    string item_uuid
    
    # The grasp orientation is defined such that:
    # - the z axis is the normal of the surface at the grasp position
    # - the x axis is directed along the direction of maximum elongation of the surface
    # - the y axis is selected to form a right-handed coordinate system
    geometry_msgs/PoseStamped pose
    
    # Optional. The quality of the grasp (between 0 and 1)
    float64 quality
    
    # Optional. The axis lengths of the biggest ellipse inscribed on the suction surface
    float64 max_suction_surface_length
    float64 max_suction_surface_width
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new SuctionGrasp(null);
    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    if (msg.item_uuid !== undefined) {
      resolved.item_uuid = msg.item_uuid;
    }
    else {
      resolved.item_uuid = ''
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.PoseStamped.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.PoseStamped()
    }

    if (msg.quality !== undefined) {
      resolved.quality = msg.quality;
    }
    else {
      resolved.quality = 0.0
    }

    if (msg.max_suction_surface_length !== undefined) {
      resolved.max_suction_surface_length = msg.max_suction_surface_length;
    }
    else {
      resolved.max_suction_surface_length = 0.0
    }

    if (msg.max_suction_surface_width !== undefined) {
      resolved.max_suction_surface_width = msg.max_suction_surface_width;
    }
    else {
      resolved.max_suction_surface_width = 0.0
    }

    return resolved;
    }
};

module.exports = SuctionGrasp;
