// Auto-generated. Do not edit!

// (in-package rc_pick_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Compartment = require('../msg/Compartment.js');
let ItemModel = require('../msg/ItemModel.js');
let CollisionDetection = require('../msg/CollisionDetection.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let Item = require('../msg/Item.js');
let SuctionGrasp = require('../msg/SuctionGrasp.js');
let LoadCarrier = require('../msg/LoadCarrier.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class ComputeBoxGraspsRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose_frame = null;
      this.region_of_interest_id = null;
      this.load_carrier_id = null;
      this.load_carrier_compartment = null;
      this.item_models = null;
      this.suction_surface_length = null;
      this.suction_surface_width = null;
      this.robot_pose = null;
      this.collision_detection = null;
    }
    else {
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('region_of_interest_id')) {
        this.region_of_interest_id = initObj.region_of_interest_id
      }
      else {
        this.region_of_interest_id = '';
      }
      if (initObj.hasOwnProperty('load_carrier_id')) {
        this.load_carrier_id = initObj.load_carrier_id
      }
      else {
        this.load_carrier_id = '';
      }
      if (initObj.hasOwnProperty('load_carrier_compartment')) {
        this.load_carrier_compartment = initObj.load_carrier_compartment
      }
      else {
        this.load_carrier_compartment = new Compartment();
      }
      if (initObj.hasOwnProperty('item_models')) {
        this.item_models = initObj.item_models
      }
      else {
        this.item_models = [];
      }
      if (initObj.hasOwnProperty('suction_surface_length')) {
        this.suction_surface_length = initObj.suction_surface_length
      }
      else {
        this.suction_surface_length = 0.0;
      }
      if (initObj.hasOwnProperty('suction_surface_width')) {
        this.suction_surface_width = initObj.suction_surface_width
      }
      else {
        this.suction_surface_width = 0.0;
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('collision_detection')) {
        this.collision_detection = initObj.collision_detection
      }
      else {
        this.collision_detection = new CollisionDetection();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ComputeBoxGraspsRequest
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [region_of_interest_id]
    bufferOffset = _serializer.string(obj.region_of_interest_id, buffer, bufferOffset);
    // Serialize message field [load_carrier_id]
    bufferOffset = _serializer.string(obj.load_carrier_id, buffer, bufferOffset);
    // Serialize message field [load_carrier_compartment]
    bufferOffset = Compartment.serialize(obj.load_carrier_compartment, buffer, bufferOffset);
    // Serialize message field [item_models]
    // Serialize the length for message field [item_models]
    bufferOffset = _serializer.uint32(obj.item_models.length, buffer, bufferOffset);
    obj.item_models.forEach((val) => {
      bufferOffset = ItemModel.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [suction_surface_length]
    bufferOffset = _serializer.float64(obj.suction_surface_length, buffer, bufferOffset);
    // Serialize message field [suction_surface_width]
    bufferOffset = _serializer.float64(obj.suction_surface_width, buffer, bufferOffset);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    // Serialize message field [collision_detection]
    bufferOffset = CollisionDetection.serialize(obj.collision_detection, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ComputeBoxGraspsRequest
    let len;
    let data = new ComputeBoxGraspsRequest(null);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [region_of_interest_id]
    data.region_of_interest_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [load_carrier_id]
    data.load_carrier_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [load_carrier_compartment]
    data.load_carrier_compartment = Compartment.deserialize(buffer, bufferOffset);
    // Deserialize message field [item_models]
    // Deserialize array length for message field [item_models]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.item_models = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.item_models[i] = ItemModel.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [suction_surface_length]
    data.suction_surface_length = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [suction_surface_width]
    data.suction_surface_width = _deserializer.float64(buffer, bufferOffset);
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [collision_detection]
    data.collision_detection = CollisionDetection.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += _getByteLength(object.pose_frame);
    length += _getByteLength(object.region_of_interest_id);
    length += _getByteLength(object.load_carrier_id);
    object.item_models.forEach((val) => {
      length += ItemModel.getMessageSize(val);
    });
    length += CollisionDetection.getMessageSize(object.collision_detection);
    return length + 168;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/ComputeBoxGraspsRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'fa640774f984fc6944b698c3211fbfaa';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Description: Triggers the computation of grasp poses for the given box items and suction surface.
    
    # A valid pose_frame (either camera or external) is required in the request.
    # It can be provided either with the pose_frame field, as pose_frame of the selected region of interest
    # or as pose_frame of the selected load carrier.
    # If more than one pose_frame is provided, they must to be consistent.
    
    # Optional. Pose frame for output poses.
    string pose_frame
    
    # Optional
    string region_of_interest_id
    
    # Optional
    string load_carrier_id
    
    # Optional
    Compartment load_carrier_compartment
    
    # Required
    ItemModel[] item_models
    
    # Required. Dimensions of the gripper suction surface
    # In case of circular suction cups, the two values are expected to be the same and set to the suction cup diameter
    # Different values are expected for grippers with multiple suction cups or non-circular suction cups (e.g. oval cups)
    float64 suction_surface_length
    float64 suction_surface_width
    
    # Required only if reference frame = external and sensor is robot-mounted
    geometry_msgs/Pose robot_pose
    
    # Optional. Enables collision checking of grasps with load carrier
    CollisionDetection collision_detection
    
    
    ================================================================================
    MSG: rc_pick_client/Compartment
    # Definition of a load carrier compartment
    
    # The pose of the compartment is relative to the load carrier
    geometry_msgs/Pose pose
    
    # Size of the compartment
    Box box
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_pick_client/ItemModel
    # Definition of an item model for the ItemPick and BoxPick components
    
    # Required
    string type
    
    # Supported types (depending on component)
    string UNKNOWN=UNKNOWN
    string RECTANGLE=RECTANGLE
    
    # Only one of those required depending on the selected type
    # In case of unknown type, these values defines an optional bounding box for the item
    RangeBox unknown
    RangeRectangle rectangle
    
    ================================================================================
    MSG: rc_pick_client/RangeBox
    # Definition of a box with minimum and maximum dimensions
    
    Box min_dimensions
    Box max_dimensions
    
    ================================================================================
    MSG: rc_pick_client/RangeRectangle
    # Definition of a rectangle with minimum and maximum dimensions
    
    Rectangle min_dimensions
    Rectangle max_dimensions
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: rc_pick_client/CollisionDetection
    string gripper_id
    
    geometry_msgs/Point pre_grasp_offset
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ComputeBoxGraspsRequest(null);
    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.region_of_interest_id !== undefined) {
      resolved.region_of_interest_id = msg.region_of_interest_id;
    }
    else {
      resolved.region_of_interest_id = ''
    }

    if (msg.load_carrier_id !== undefined) {
      resolved.load_carrier_id = msg.load_carrier_id;
    }
    else {
      resolved.load_carrier_id = ''
    }

    if (msg.load_carrier_compartment !== undefined) {
      resolved.load_carrier_compartment = Compartment.Resolve(msg.load_carrier_compartment)
    }
    else {
      resolved.load_carrier_compartment = new Compartment()
    }

    if (msg.item_models !== undefined) {
      resolved.item_models = new Array(msg.item_models.length);
      for (let i = 0; i < resolved.item_models.length; ++i) {
        resolved.item_models[i] = ItemModel.Resolve(msg.item_models[i]);
      }
    }
    else {
      resolved.item_models = []
    }

    if (msg.suction_surface_length !== undefined) {
      resolved.suction_surface_length = msg.suction_surface_length;
    }
    else {
      resolved.suction_surface_length = 0.0
    }

    if (msg.suction_surface_width !== undefined) {
      resolved.suction_surface_width = msg.suction_surface_width;
    }
    else {
      resolved.suction_surface_width = 0.0
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    if (msg.collision_detection !== undefined) {
      resolved.collision_detection = CollisionDetection.Resolve(msg.collision_detection)
    }
    else {
      resolved.collision_detection = new CollisionDetection()
    }

    return resolved;
    }
};

class ComputeBoxGraspsResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.items = null;
      this.grasps = null;
      this.load_carriers = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('items')) {
        this.items = initObj.items
      }
      else {
        this.items = [];
      }
      if (initObj.hasOwnProperty('grasps')) {
        this.grasps = initObj.grasps
      }
      else {
        this.grasps = [];
      }
      if (initObj.hasOwnProperty('load_carriers')) {
        this.load_carriers = initObj.load_carriers
      }
      else {
        this.load_carriers = [];
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ComputeBoxGraspsResponse
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [items]
    // Serialize the length for message field [items]
    bufferOffset = _serializer.uint32(obj.items.length, buffer, bufferOffset);
    obj.items.forEach((val) => {
      bufferOffset = Item.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [grasps]
    // Serialize the length for message field [grasps]
    bufferOffset = _serializer.uint32(obj.grasps.length, buffer, bufferOffset);
    obj.grasps.forEach((val) => {
      bufferOffset = SuctionGrasp.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [load_carriers]
    // Serialize the length for message field [load_carriers]
    bufferOffset = _serializer.uint32(obj.load_carriers.length, buffer, bufferOffset);
    obj.load_carriers.forEach((val) => {
      bufferOffset = LoadCarrier.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ComputeBoxGraspsResponse
    let len;
    let data = new ComputeBoxGraspsResponse(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [items]
    // Deserialize array length for message field [items]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.items = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.items[i] = Item.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [grasps]
    // Deserialize array length for message field [grasps]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.grasps = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.grasps[i] = SuctionGrasp.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [load_carriers]
    // Deserialize array length for message field [load_carriers]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.load_carriers = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.load_carriers[i] = LoadCarrier.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.items.forEach((val) => {
      length += Item.getMessageSize(val);
    });
    object.grasps.forEach((val) => {
      length += SuctionGrasp.getMessageSize(val);
    });
    object.load_carriers.forEach((val) => {
      length += LoadCarrier.getMessageSize(val);
    });
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 20;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/ComputeBoxGraspsResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '387f6388cc8804f00920c4ee699ae577';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    time timestamp
    
    Item[] items
    
    SuctionGrasp[] grasps
    
    LoadCarrier[] load_carriers
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_pick_client/Item
    # Definition of a detected item
    
    string uuid
    
    # Contains uuids of grasps on this object (if requested)
    string[] grasp_uuids
    
    string type
    
    # Types
    string RECTANGLE=RECTANGLE
    
    # if type==RECTANGLE
    Rectangle rectangle
    
    # The pose of the item
    geometry_msgs/PoseStamped pose
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_pick_client/SuctionGrasp
    # Definition of a suction grasp for the itempick component
    
    string uuid
    
    # Optional
    string item_uuid
    
    # The grasp orientation is defined such that:
    # - the z axis is the normal of the surface at the grasp position
    # - the x axis is directed along the direction of maximum elongation of the surface
    # - the y axis is selected to form a right-handed coordinate system
    geometry_msgs/PoseStamped pose
    
    # Optional. The quality of the grasp (between 0 and 1)
    float64 quality
    
    # Optional. The axis lengths of the biggest ellipse inscribed on the suction surface
    float64 max_suction_surface_length
    float64 max_suction_surface_width
    
    ================================================================================
    MSG: rc_pick_client/LoadCarrier
    # This represents a load carrier by its geometry and its pose
    
    string id
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    geometry_msgs/PoseStamped pose
    
    # True if a detected load carrier is overfilled. Ignored on setting load carrier.
    bool overfilled
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ComputeBoxGraspsResponse(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.items !== undefined) {
      resolved.items = new Array(msg.items.length);
      for (let i = 0; i < resolved.items.length; ++i) {
        resolved.items[i] = Item.Resolve(msg.items[i]);
      }
    }
    else {
      resolved.items = []
    }

    if (msg.grasps !== undefined) {
      resolved.grasps = new Array(msg.grasps.length);
      for (let i = 0; i < resolved.grasps.length; ++i) {
        resolved.grasps[i] = SuctionGrasp.Resolve(msg.grasps[i]);
      }
    }
    else {
      resolved.grasps = []
    }

    if (msg.load_carriers !== undefined) {
      resolved.load_carriers = new Array(msg.load_carriers.length);
      for (let i = 0; i < resolved.load_carriers.length; ++i) {
        resolved.load_carriers[i] = LoadCarrier.Resolve(msg.load_carriers[i]);
      }
    }
    else {
      resolved.load_carriers = []
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: ComputeBoxGraspsRequest,
  Response: ComputeBoxGraspsResponse,
  md5sum() { return '211b262b58fcc676c21dfc5791187a2f'; },
  datatype() { return 'rc_pick_client/ComputeBoxGrasps'; }
};
